unit Analizador;

interface
uses
    Windows;

const
    // Tamao mximo de las cadenas tanto de entrada como de salida.
    ANA_MAX_CADENA =                1024;

    // Definicin de tipos de datos.
    ANA_TIPO_NUMERO =                1;
    ANA_TIPO_TEXTO =                 2;

    // Definicin de errores.
    // **** Errores sintcticos
    ANA_ERROR_NOERROR =              0;   // No hay error.
    ANA_ERROR_NOOPERADOR =           100; // Se esperaba un operador.
    ANA_ERROR_NONUMERICO =           200; // Se esperaba un valor numrico.
    ANA_ERROR_NOPARENTESIS =         300; // Se esperaba un parntesis cerrado.
    ANA_ERROR_NOCIERREFUNCION =      400; // Se esperaba un parntesis de cierre de funcin.
    ANA_ERROR_NOOPERANDO =           500; // Se esperaba un operando.
    ANA_ERROR_NOSEPARADOR =          600; // Se esperaba un separador de listas ; .
    ANA_ERROR_TIPOOPERANDOS =        700; // Los operandos son de distinto tipo.
    ANA_ERROR_CARACTERNOVALIDO =     800;  // Se ha encontrado un carcter no valido.
    // Estos dos ltimos valores deben ser activados por el programador en las
    // funciones TPedirVariable y TPedirFuncion.
    ANA_ERROR_NOVARIABLE =           1000; // No es una variable vlida.
    ANA_ERROR_NOFUNCION =            1100; // No es una funcin vlida.
    // **** Errores semnticos
    ANA_ERROR_DIVISION  =            1200; // Se ha producido una divisin por cero.


type
    // definicin del bloque de datos.
    BLOQUEDEDATOS = record
        Numero: double;
        Texto: array[1..ANA_MAX_CADENA] of Char;
        Tipo: Byte;
        Error: LongInt;
        PosError: LongInt;
    end;

    // Se reservan 2088 bytes que usar la DLL internamente.
    ANADATOSDECONTEXTO = record
        Nada: array [1..2088] of Char;
    end;

    TipoCadena = array[1..ANA_MAX_CADENA] of Byte;
    TipoParametros = array[1..10] of BLOQUEDEDATOS;

    // Declaracin de eventos.
    TPedirVariable = procedure(var Variable: TipoCadena; var D: BLOQUEDEDATOS) stdcall;
    TPedirFuncion = procedure(var Funcion: TipoCadena;
        var Parametros: TipoParametros; N: LongInt; var D: BLOQUEDEDATOS) stdcall;


procedure A_Inicializar(var D: ANADATOSDECONTEXTO) stdcall;
          external 'Analizador.dll';
procedure A_AsignarAlPedir(var D: ANADATOSDECONTEXTO; Pv: Pointer;
          Pf: Pointer) stdcall; external 'Analizador.dll';
procedure A_AsignarSeparadores(var D: ANADATOSDECONTEXTO; Sm: Byte;
          Sd: Byte) stdcall; external 'Analizador.dll';
function A_Analizar(var D: ANADATOSDECONTEXTO; var S: TipoCadena):
         BLOQUEDEDATOS; stdcall; external 'Analizador.dll';

implementation

end.
