//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Analizadorcpp.h"

#include "Pa.h"

#include<math.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
    BLOQUEDEDATOS R;
    ANADATOSDECONTEXTO D;
    AnsiString S;

    Resultado->Text="";

    A_Inicializar(&D);

    A_AsignarAlPedir(&D, PedirVariable, PedirFuncion);

    R=A_Analizar(&D, Expresion->Text.c_str());

    S="Error: ";
    if(R.Error){
        switch(R.Error){
            case ANA_ERROR_NOOPERADOR:
                S+="Se esperaba un operador en la posicin ";
                S+=R.PosError;
                break;
            case ANA_ERROR_NONUMERICO:
                S+="Se ha encontrado un valor que no puede ser evaluado como una expresin numrica en la posicin ";
                S+=R.PosError;
                break;
            case ANA_ERROR_NOPARENTESIS:
                S+="Se esperaba un parntesis en la posicin ";
                S+=R.PosError;
                break;
            case ANA_ERROR_NOCIERREFUNCION:
                S+="Se esperaba un parntesis de cierre de funcin en la posicin ";
                S+=R.PosError;
                break;
            case ANA_ERROR_NOOPERANDO:
                S+="Se esperaba un operando en la posicin ";
                S+=R.PosError;
                break;
            case ANA_ERROR_NOSEPARADOR:
                S+="Se esperaba un separador de lista en la posicin ";
                S+=R.PosError;
                break;
            case ANA_ERROR_NOVARIABLE:
                S+="Se esperaba una variable en la posicin ";
                S+=R.PosError;
                break;
            case ANA_ERROR_NOFUNCION:
                S+="Se esperaba una funcin en la posicin ";
                S+=R.PosError;
                break;
            case ANA_ERROR_TIPOOPERANDOS:
                S+="Los operandos no son compatibles en la posicin ";
                S+=R.PosError;
                break;
            case ANA_ERROR_DIVISION:
                S+="Error de divisin en la posicin ";
                S+=R.PosError;
                break;
	    case ANA_ERROR_CARACTERNOVALIDO:
                S+="Se ha encontrado un caracter no valido en la posicion ";
                S+=R.PosError;
                break;
        }
        Application->MessageBox(S.c_str(), "Error", IDOK);
        return;
    }

    if(R.Tipo==ANA_TIPO_TEXTO)
        Resultado->Text=R.Texto;
    else
        Resultado->Text=(double)R.Numero;
}

//---------------------------------------------------------------------------
void _fastcall TForm1::PedirVariable(char *Variable, BLOQUEDEDATOS *R){
   if(!stricmp(Variable, "Euro")){
        R->Numero=1/166.386;
        R->Tipo=ANA_TIPO_NUMERO;
   }
   else if(!stricmp(Variable, "Pesetas")){
        R->Numero=166.386;
        R->Tipo=ANA_TIPO_NUMERO;
   }
   else if(!stricmp(Variable, "Hora")){
        strcpy(R->Texto, TimeToStr(Time()).c_str());
        R->Tipo=ANA_TIPO_TEXTO;
   }
   else if(!stricmp(Variable, "Fecha")){
        strcpy(R->Texto, DateToStr(Date()).c_str());
        R->Tipo=ANA_TIPO_TEXTO;
   }
   else
        R->Error=ANA_ERROR_NOVARIABLE;
}

void _fastcall TForm1::PedirFuncion(char *Funcion, BLOQUEDEDATOS *Parametros,
  int N, BLOQUEDEDATOS *R){
    if(!strcmpi(Funcion, "Raiz") && N==1){
        R->Tipo=ANA_TIPO_NUMERO;
        R->Numero=sqrt(Parametros[0].Numero);
    }else if(!strcmpi(Funcion, "Seno") && N==1){
        R->Tipo=ANA_TIPO_NUMERO;
        R->Numero=sin(Parametros[0].Numero);
    }else
    if(!strcmpi(Funcion, "si") && N==3){
        if(Parametros[0].Tipo!=ANA_TIPO_NUMERO){
            R->Error=ANA_ERROR_TIPOOPERANDOS;
            return;
        }
        if(Parametros[0].Numero==0)
            *R=Parametros[2];
        else
            *R=Parametros[1];
    }else
        R->Error=ANA_ERROR_NOFUNCION;
}

